<?php
/*
Plugin Name: Geocache Stat Bar Widget
Plugin URI: http://www.trassare.com/the-official-geocache-stat-bar-widget/
Description: Display your Geocache Stat Bar
Author: Brandon Dove, Jeffrey Zinn, Samuel T. Trassare
Version: 0.91.1
Author URI: http://www.pixeljar.net/
Text Domain: geocache-stat-bar-widget
Domain Path: /languages
*/

function widget_geocache_stat_bar_init()
{
    
    if (!function_exists('register_sidebar_widget'))
        return;

    function widget_geocache_stat_bar($args)
    {
        
        extract($args);
        
        $options  = get_option('widget_geocache_stat_bar');
        $username = $options['username'];
        $guid     = $options['guid'];
        $image    = $options['image'];
        $message  = $options['message'];
        $m        = str_replace(' ', '+', $message);
        
        $statBar = '<a href="http://www.geocaching.com/profile/?guid=' . $guid . '" target="_blank"><img src="http://img.geocaching.com/stats/img.aspx?txt=' . $m . '&uid=' . $guid . '&bg=' . $image . '" border="0" title="';
        /* translators: This is the value for the HTML img title tag and alt text. */
        $statBar .= sprintf(__('Profile for %s', 'geocache-stat-bar-widget'), $username);
        $statBar .= '" alt="';
        $statBar .= sprintf(__('Profile for %s', 'geocache-stat-bar-widget'), $username);
        $statBar .= '"></a>';
        
        echo $before_widget . $before_title . 'Geocaching' . $after_title . $statBar . $after_widget;
    }
    
    function widget_geocache_stat_bar_control()
    {
        
        $options = get_option('widget_geocache_stat_bar');
        if (!is_array($options))
            $options = array(
            	/* translators: The default username for the stat message and one of the options for the selected geocaching image. */
                'username' => __('Signal the Frog', 'geocache-stat-bar-widget'),
                'guid' => '0',
                'image' => '1',
                /* translators: The default message for the stat image. */
                'message' => __("Let's go geocaching!", 'geocache-stat-bar-widget')
            );
        if ($_POST['gsb-submit']) {
            
            $options['username'] = strip_tags(stripslashes($_POST['gsb-username']));
            $options['guid']     = strip_tags(stripslashes($_POST['gsb-guid']));
            $options['image']    = strip_tags(stripslashes($_POST['gsb-image']));
            $options['message']  = strip_tags(stripslashes($_POST['gsb-message']));
            update_option('widget_geocache_stat_bar', $options);
        }
        
        echo '<p style="text-align:right;"><label for="gsb-username">';
        /* translators: The prompt for the geocaching username in the widget settings dialog. */
        _e('Username:', 'geocache-star-bar-widget');
        echo ' <input style="width: 200px;" id="gsb-username" name="gsb-username" type="text" value="';
        echo $options['username'];
        echo '" /></label></p>';
        
        echo '<p style="text-align:right;"><label for="gsb-guid">UID: <input style="width: 200px;" id="gsb-guid" name="gsb-guid" type="text" value="';
        echo $options['guid'];
        echo '" /></label></p>';
        
        echo '<p style="text-align:right;"><label for="gsb-image">';
        /* translators: The prompt for which image should be displayed. */
        _e('Image:', 'geocache-stat-bar-widget');
        echo ' <select style="width: 200px;" id="gsb-image" name="gsb-image"><option value="1"';
        if ($options['image'] == 1) {
            echo 'selected="selected"';
        }
        echo '>';
        /* translators: The official geocaching logo graphic in the drop-down menu. */
        _e('Geocaching Logo', 'geocache-stat-bar-widget');
        echo '</option><option value="2" ';
        if ($options['image'] == 2) {
            echo 'selected="selected"';
        }
        echo '>';
        _e('Signal the Frog', 'geocache-stat-bar-widget');
        echo '</option></label></p>';
        
        echo '<p style="text-align:right;"><label for="gsb-message">';
        /* translators: The prompt for the message the user can display at the bottom of the graphic. */
        _e('Message:', 'geocache-stat-bar-widget');
        echo ' <input style="width: 200px;" id="gsb-message" name="gsb-message" type="text" value="';
        echo $options['message'];
        echo '" /></label></p>';
        
        echo '<input type="hidden" id="gsb-submit" name="gsb-submit" value="1" />';
    }
    
    register_sidebar_widget('Geocache Stat Bar', 'widget_geocache_stat_bar');
    
    register_widget_control('Geocache Stat Bar', 'widget_geocache_stat_bar_control', 300, 200);
}

add_action('plugins_loaded', 'widget_geocache_stat_bar_init');

?>
